Vulnerabilities

Vulnerability · CVE-2026-114101

Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza

Published Oct 8, 2026 · catalog updated Oct 21, 2026 · Coraza: Multipart filename* (RFC

Open the advisory

Exploitation likelihood is not on this record for CVE-2026-114101. A missing EPSS score is not a low risk. Compare Coraza: Multipart filename* (RFC with the linked advisory before you change production.

Gaps on this record

  • The stored product name is a package slug. The name on this page is taken from the title (Coraza: Multipart filename* (RFC).
  • No vendor fix or required action is stored. Compare the linked advisory before you change production.
  • EPSS is missing. A missing score is not a low risk.
Severity
Medium4.0
Known exploitation
Not in CISA/VulnCheck KEV
EPSS
Awaiting synchronization with FIRST
Remediation
Advisory link
Affected products
Go github.com/corazawaf/coraza · Go github.com/corazawaf/coraza/v2 · Go github.com/corazawaf/coraza/v3

## Summary Coraza extracts a multipart file upload's filename using Go's standard-library , which only decodes the RFC 5987/6266 extended parameter when its declared charset is exactly or . Any other charset — including , which RFC 5987 explicitly permits — is silently dropped by the stdlib, with no error and no fallback signal. This lets an attacker present one filename to Coraza and a different one to the backend application in the same request. ## Affected variables (documented as *"the original filenames as submitted by the client in the multipart upload"*), , and the file-vs-field routing decision that determines whether a part is tracked as a file at all. is not affected. It is declared in Coraza but is not populated by any code path in the affected versions. ## Details 's calls on the raw header and reads , which then populates / for parts recognized as file uploads. Per RFC 7578 §4.2 and RFC 6266, when both and are present, is authoritative. Go's implements this precedence internally ( in ), but only for values whose charset token is or : When returns , the stdlib silently leaves whatever was parsed for the plain parameter untouched (or leaves absent entirely if only was supplied) — there is no error, no partial-parse indicator, nothing a caller can detect. The stdlib also discards the RFC 5987 component of entirely; it is not recoverable from the parsed params map at all. ### Verified behavior (prior to the fix) | fields | Effective filename ( ) | Recognized as file upload? | |---|---|---| | | (correct) | yes | | | (decoy wins) | yes, but with the wrong name | | (no plain ) | *(none)* | **no** — processed as an ordinary form field into instead | In the second row, any rule inspecting for a dangerous extension only ever sees , while a backend that follows RFC 7578 precedence and accepts (an RFC-5987-legal, non-exotic charset) uses as the filename. In the third row, the upload skips file-specific rule scope and size-limit tracking ( ) entirely. ## Impact A ru

Are you affected?

Enter the version you run. The result uses only the ranges stored on this record.

The check returns affected, not affected, or incomplete. It does not guess a version that is missing from the record.

  • Go github.com/corazawaf/corazaversion unspecified
  • Go github.com/corazawaf/coraza/v2version unspecified
  • Go github.com/corazawaf/coraza/v30 → 3.8.1

How to fix CVE-2026-114101

What to do

Three questions, each answered from this record only. Confirm the vendor advisory before you patch.

Should you patch?

Exploitation likelihood is not on this record for CVE-2026-114101. A missing EPSS score is not a low risk. Compare Coraza: Multipart filename* (RFC with the linked advisory before you change production.

Which versions are affected?

Compare what you have installed with 0 → 3.8.1. Compare the installed version with the linked vendor advisory before you change production.

What should an analyst verify?

CWE-20: Improper Input Validation; CWE-436. EPSS is not on this record yet. There is no CISA KEV listing. No Exploit-DB or Metasploit reference is linked. Use the source links for the original advisory.

Code

The project this record applies to. Exploit listings stay in References.

Timeline

Detection, updates, and resolution for this record.

  1. Oct 19, 2026 · GitHub Advisory Database

    Detected

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza

  2. Oct 21, 2026 · GitHub Advisory Database

    Fix available

    github.com/corazawaf/coraza/v3 fixed in 3.8.1

  3. Oct 21, 2026 · GitHub Advisory Database

    Fix available

    github.com/corazawaf/coraza/v3 fixed in 3.8.1

  4. Oct 21, 2026 · GitHub Advisory Database

    Updated

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza

Sources

  • CVE.orgVulnerability recordCVE-2026-114101

    Official CVE identifier

    cve.org
  • GitHub Advisory DatabasePackage advisoryGHSA-3wr7-993q-jrff

    GitHub Advisory Database record mirrored by OSV.

    github.com
  • Go Vulnerability DatabasePackage advisoryGHSA-3wr7-993q-jrff

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules

    osv.dev
  • Go Vulnerability DatabasePackage advisoryGO-2026-6691

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza

    osv.dev
  • OpenSSF OSV / OSV ScannerPackage advisoryGHSA-3wr7-993q-jrff

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules

    osv.dev
  • OpenSSF OSV / OSV ScannerPackage advisoryGO-2026-6691

    Coraza: Multipart filename* (RFC 5987) charset restriction lets a decoy filename bypass FILES-based rules in github.com/corazawaf/coraza

    osv.dev

References

Freshness

Last verified in this catalog Oct 21, 2026. Significant claims (KEV, EPSS, CVSS, affected ranges) come from the source rows above — open the original publisher for the authoritative advisory.